-----------------------------------------------------------------------------
--   Copyright (C) 2011 by Christoph Thelen                                --
--   doc_bacardi@users.sourceforge.net                                     --
--                                                                         --
--   This program is free software; you can redistribute it and/or modify  --
--   it under the terms of the GNU General Public License as published by  --
--   the Free Software Foundation; either version 2 of the License, or     --
--   (at your option) any later version.                                   --
--                                                                         --
--   This program is distributed in the hope that it will be useful,       --
--   but WITHOUT ANY WARRANTY; without even the implied warranty of        --
--   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         --
--   GNU General Public License for more details.                          --
--                                                                         --
--   You should have received a copy of the GNU General Public License     --
--   along with this program; if not, write to the                         --
--   Free Software Foundation, Inc.,                                       --
--   59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.             --
-----------------------------------------------------------------------------

require("wx")


local muhkuh_test_untested_32_xpm = {
"32 32 16 1",
"       c None",
".      c #121212",
"+      c #242424",
"@      c #373737",
"#      c #000000",
"$      c #494949",
"%      c #6D6D6D",
"&      c #808080",
"*      c #5B5B5B",
"=      c #A4A4A4",
"-      c #EDEDED",
";      c #FFFFFF",
">      c #C8C8C8",
",      c #DBDBDB",
"'      c #B6B6B6",
")      c #929292",
"                .               ",
"          .+   @@       #       ",
"          +$+%&$+     +*=%      ",
"          .$-;;;=.  .&&>>>#     ",
"          .,;;;;;,%%'>')*.      ",
"      ##.@';;;;;;;%##           ",
"   $%%'%+@))=)=;')=)            ",
"  *&>'+  =;;;;,&==>;)           ",
"  )>)#  ,;;;=';%,%=;&           ",
"  =)#  %;;;;&=;))==*            ",
"  +#   $;;;;;-&-;--'            ",
"        $='=)=-;;;;;+           ",
"          #';;;;;;;;&           ",
"           >;;;;;;;;-@          ",
"          #-;;;;;;;;;>.         ",
"          $;;;;;;;;;;;'.        ",
"          =;;;;;;;;;;,&+@$$.    ",
"         +,-;;;;;;;>**=,>**)$   ",
"       .@*%*$*)>>)$*>,,,>@%@'#  ",
"     +=,,,,,,>=&&=,,,,,,,>)=,@  ",
"    +>&@@),,,,,,,,,,,,,,,,,,,$  ",
"    &=$=)*,,,,,,,,,,,,,,,,,,,@  ",
"    =)$%@',,,,,,,,,,,,,,,,,,>#  ",
"   #',=)>,,,,,,,,,,,,,,,,,,,$   ",
"    ',,,,,,,,,,,,,,,,,,,,,,%    ",
"    %,,,,,,,,,,,,,,,,>>'=)@     ",
"    .',,,,,,,,,>&$$$$**%&&+     ",
"     .%>,,,,=%$*)>,,,,,,,,$     ",
"       #+@@$%',,,,>'))&%%$      ",
"          &,,,>&$$*&=*          ",
"          $)%$*=-;;;;'          ",
"           $>;;;;;;;;-.         "}


local muhkuh_test_ok_32_xpm = {
"32 32 23 1",
"       c None",
".      c #245B24",
"+      c #122412",
"@      c #244924",
"#      c #498049",
"$      c #5BB65B",
"%      c #000000",
"&      c #80FF80",
"*      c #375B37",
"=      c #376D37",
"-      c #378037",
";      c #243724",
">      c #5BA45B",
",      c #49A449",
"'      c #6DDB6D",
")      c #001200",
"!      c #499249",
"~      c #6DC86D",
"{      c #6DED6D",
"]      c #5BC85B",
"^      c #123712",
"/      c #80ED80",
"(      c #121212",
"                                ",
"             .+  +@             ",
"             +#$$.+             ",
"            %$&&&&*    %@=.     ",
"     @==-=+.$&&&&&&=+;#>,,')    ",
"    *!~,@) +{&&&&&&'@*=!!!.     ",
"    >'=%   +!,$&&],,=           ",
"    -^     {&,$]{>>~&-          ",
"          *&&@>${$#$&=          ",
"           =>,,&&$,,.           ",
"           %~&&&&&&&@           ",
"           )&&&&&&&&=           ",
"           @&&&&&&&&>           ",
"           >&&&&&&&&/+          ",
"          @&&&&&&&&&&!          ",
"         ('&&&&&&&&&&&;         ",
"     %@*==..!/&&&&&&',.%%       ",
"    ($$#>''',.=>$,=@=,$]!#;     ",
"    !!@-@>'''']!!,]''''$;@#^    ",
"   ('.!!@$''''''''''''''-@=#    ",
"   ;'$*=$''''''''''''''''''!    ",
"   @'''''''''''''''''''''''#    ",
"   +'''''''''''''''''''''''@    ",
"    ='''''''''''''''''''''!     ",
"     *~''''''''~]~'''''''#%     ",
"      )@-#-*@.;.-+*.;.*=^       ",
"         )=,.&>$&*&{@$=         ",
"        +,>!=.@@.@.*-!!*        ",
"        ;''''''''''''''$        ",
"         +=>'''''''''>=(        ",
"           ^*.......*#%         ",
"           !&&&&&&&&&&^         "}


local muhkuh_test_failed_32_xpm = {
"32 32 23 1",
"       c None",
".      c #5B2424",
"+      c #241212",
"@      c #121212",
"#      c #492424",
"$      c #371212",
"%      c #924949",
"&      c #372424",
"*      c #000000",
"=      c #FF8080",
"-      c #5B3737",
";      c #B65B5B",
">      c #DB6D6D",
",      c #C85B5B",
"'      c #6D3737",
")      c #A44949",
"!      c #ED6D6D",
"~      c #804949",
"{      c #ED8080",
"]      c #C86D6D",
"^      c #803737",
"/      c #A45B5B",
"(      c #120000",
"                                ",
"             .+  @#             ",
"            @$.%%#&             ",
"            *%====-             ",
"         *+.;======.            ",
"       +%>%&%%,====>'.$*        ",
"      -%='@>==)!==~;#$;,'#      ",
"     #~{' %==={)=;>={  #])$     ",
"     )>.  ,==^-%=%^#=-  *..     ",
"     ^#   ,==>,/=;;>=#          ",
"          %===)!==%,^           ",
"           )>);====]~           ",
"           #;!======,           ",
"           %========{@          ",
"          +{========='          ",
"          /==========!@         ",
"         .{===========%         ",
"     +.'''#./======={;%(        ",
"    ^>)%]>>]~#~,>,%.#^);/~.*    ",
"   #]#-'#>>>>>/''^)>>>>>.##%*   ",
"   /%')~#>>>>>>>>>>>>>>>%&#%$   ",
"  (>]##-,>>>>>>>>>>>>>>>>];>.   ",
"  +>>>>>>>>>>>>>>>>>>>>>>>>>#   ",
"  (>>>>>>>>>>>>>>>>>>>>>>>>>+   ",
"   ^>>>>>>>>>>>>>>>>>>>>>>>%    ",
"   *%>>>>>>>>>>>>>>>>>>>>>/(    ",
"     #)>>>>];%^'''~);]>>]^(     ",
"       (+###'~);;;)~'.#&(       ",
"       *;>>>>>>>>>>>>>>>&       ",
"       *,>>,%-####-%;>>>$       ",
"        +#++)>====>/'##&        ",
"           '========={(         "}


local icon_famfamfam_silk_folder = {
"16 16 125 2",
"   c #F1CE30",
" . c #F6E1AC",
" X c #F4D754",
" o c #E3C76B",
" O c #F3D449",
" + c #FAEDB3",
" @ c #F1D272",
" # c #FFFDFA",
" $ c #F7E385",
" % c #F4D757",
" & c #FEFAEF",
" * c #FAECAC",
" = c #F3D88E",
" - c #FEFCF2",
" ; c #FDFAF1",
" : c #F9E9A1",
" > c #F6E9C9",
" , c #F7E38B",
" < c #F9E9A4",
" 1 c #FCF2C8",
" 2 c #F6DF76",
" 3 c #F6DC6C",
" 4 c #E2C35F",
" 5 c #FBF2CA",
" 6 c #DAAA36",
" 7 c #FEFBEE",
" 8 c #F2D47F",
" 9 c #DA9A36",
" 0 c #F6DE72",
" q c #F4D85C",
" w c #FEFDF4",
" e c #D8872D",
" r c #F5E09F",
" t c #F8E48E",
" y c #FFFDF8",
" u c #DAAF35",
" i c #DAAB35",
" p c #DA9F35",
" a c #F0CB26",
" s c #F5DA63",
" d c #FCF4D7",
" f c #F1CF69",
" g c #FEFCF0",
" h c #D8B22C",
" j c #F2D581",
" k c #F8E694",
" l c #FFFFFE",
" z c #F5DE91",
" x c #FCF3D0",
" c c #FEFCF3",
" v c #FDFAF2",
" b c #D8862C",
" n c #F8EAC2",
" m c #F5DE94",
" M c #F4DC93",
" N c #FEFCF6",
" B c #DAAE34",
" V c #FBF7E9",
" C c #E2C360",
" Z c #EFD07A",
" A c #D98E33",
" S c #F7E285",
" D c #FEFBEF",
" F c #DAA637",
" G c #F5DB65",
" H c #FFFEFD",
" J c #EECF72",
" K c #EFD494",
" L c #EFD280",
" P c #F2D379",
" I c #F5DB68",
" U c #FFFDF6",
" Y c #F7E181",
" T c #D9B132",
" R c #EDCA6A",
" E c #E4C76B",
" W c #F6DE76",
" Q c #FBF6E8",
" ! c #E1C25E",
" ~ c #DAB336",
" ^ c #DAAF36",
" / c #DAAB36",
" ( c #E9C173",
" ) c #DAA136",
" _ c #FCF6D8",
" ` c #FEFCF1",
" ' c #F6E07C",
" ] c #F4D64F",
" [ c #EECE88",
" { c #F8E695",
" } c #FBEFB9",
" | c #F3D344",
".  c #FFFFFF",
".. c #F2D039",
".X c #F5D95D",
".o c #FFFCF5",
".O c #D8882D",
".+ c #F3D786",
".@ c #F1CD2E",
".# c #F3D347",
".$ c #F4DB9E",
".% c #FAF0DC",
".& c #E6CD79",
".* c #FEFCF7",
".= c #D9B434",
".- c #DAA435",
".; c #F9E89C",
".: c #EFD385",
".> c #FBF7EA",
"., c #DA9835",
".< c #F8E591",
".1 c #DA9435",
".2 c #F3DA96",
".3 c #FBF2CC",
".4 c #EACB6C",
".5 c #D8B32C",
".6 c #DBB63C",
".7 c #FFFEFE",
".8 c #FEFEFD",
".9 c #F1D06C",
".0 c #E5CA74",
".q c #F4DDA7",
".w c #EECF76",
".e c #F2D13B",
".r c None",
".r.r.r.r.r.r.r.r.r.r.r.r.r.r.r.r",
".r.r.r.r.r.r.r.r.r.r.r.r.r.r.r.r",
".r.r.r.r.r.r.r.r.r.r.r.r.r.r.r.r",
".r.= ! C C C 4.6.r.r.r.r.r.r.r.r",
".r ~.8 l.7 H l.> E o o o.&.0.r.r",
".r u.* t z r . D w c ` D 7 # ^.r",
".r 6 ; m M j R.4.: L Z.w J V B.r",
".r i Q K [ ( > - c - g D 7 l /.r",
".r F l y U.o c _ k $ 2 I q d.-.r",
".r ) N 1 } *.; , ' 3.X ] | x p.r",
".r 9 v + < { S W G % O.e  .3.,.r",
".r.1 & :.< Y 0 s X.#...@ a 5.1.r",
".r A.%.q.$.2 =.+ 8 P @.9 f n A.r",
".r.r.O e.O.O.O.O.O.O.O.O e.O b.r",
".r.r.r.r.r.r.r.r.r.r.r.r.r.r.r.r",
".r.r.r.r.r.r.r.r.r.r.r.r.r.r.r.r"}





-----------------------------------------------------------------------------
--
-- Style Info
--

local atStyle_SuperCow = {}

atStyle_SuperCow.strName = "Super Cow"

-- Create an image list for 3 images with a size of 32x32 pixel and a mask (==transparency).
local tImageList = wx.wxImageList(32, 32, true, 3)
atStyle_SuperCow.tImageList = tImageList

-- Add the images to the list.
atStyle_SuperCow.IMAGE_IDX_TestsUntested = tImageList:Add(wx.wxBitmap(muhkuh_test_untested_32_xpm))
atStyle_SuperCow.IMAGE_IDX_TestsOk       = tImageList:Add(wx.wxBitmap(muhkuh_test_ok_32_xpm))
atStyle_SuperCow.IMAGE_IDX_TestsFailed   = tImageList:Add(wx.wxBitmap(muhkuh_test_failed_32_xpm))

atStyle_SuperCow.IMAGE_IDX_Folder        = tImageList:Add(wx.wxBitmap(icon_famfamfam_silk_folder))

table.insert(tester.g_atStyles, atStyle_SuperCow)
